// copyright 1998 by anton rommerskirchen
// this code can be used and copied for free without changes
// no warrenty is given by the author
// enhancements to arommerskirchen@csi.com
// $Id: abcptrdllfact.cpp,v 1.1 2001/10/03 12:45:19 ar Exp $

// 
// create an instance of Y
// deliver the address of its counted reference ptr
//
// the abcptr instantiation is here
#ifndef INCLUDED_AR_UTILITY_ABCPTRDLLINIT_H
#	include <ar/utility/abcptrdllinit.h>
#	undef INCLUDED_AR_UTILITY_ABCPTRDLLINIT_H
#	define INCLUDED_AR_UTILITY_ABCPTRDLLINIT_H
#endif

// placement new
#ifndef INCLUDED_NEW
#	include <new>
#	undef INCLUDED_NEW
#	define INCLUDED_NEW
#endif

// the interface class
#ifndef INCLUDED_X_H
#	include "x.h"
#	undef INCLUDED_X_H
#	define INCLUDED_X_H
#endif

// the implementation class - the only place where we need it
#ifndef INCLUDED_Y_H
#	include "y.h"
#	undef INCLUDED_Y_H
#	define INCLUDED_Y_H
#endif


//----------------------------------------------------------------------------

// well. if you dont want c code here, use the full mangled name instead.
// in this case, its
// ?makeAX_InDll@@YAPAXHPAVABCPtrManager@Utility@AR@@@Z
// note:
// although the name is _makeAX_InDll, use not the _ in the program...
// ... if it is ms vc. for borland use it, for watcom its at the back ...
// happy hunting (hinthint: use map file ...)
// for borland 5.02 it is
// @makeAX_InDll$qip24AR@Utility@ABCPtrManager
//

extern "C" {

  // __declspec ( dllexport ) no ms stuff here
void*
makeAX_InDll
	(
	int i_counter,
	AR::Utility::ABCPtrManager* i_manager
	)
{
	// create an object and deliver a reference pointer
	// use the allocation and deallocation functions of manager
	// it is possible to use a delivered manager for this
	// if you use one inside the dll, be carefull at
	// disconnection of the dll

	// the allocation function has to obey the aligning rules
	// deliver the address as a void* because of the c interface...

	// well. here it is. allocate memory and initialize
	// the first reference pointer
	AR::Utility::ABCPtrDLLInit p (
		((sizeof(Y) + sizeof(AR::Utility::Chunk) - 1)
			/ sizeof (AR::Utility::Chunk) + 1)
			* sizeof(AR::Utility::Chunk),
				i_manager);

   void* addr;

	try
	{
		// use any ctor you want to use today
		// if you need different ones, use different factorys

		addr = new (p.get_adr ()) Y (i_counter);
	}

	catch (...)
	{
		// no memory leaks ...
		p.free_memory ();

		throw;
	}

	return addr;
}

} // extern "C"

// end of file


