LISTING 7

// copyright 1998 by anton rommerskirchen
// this code can be used and copied for free without changes
// no warrenty is given by the author
// enhancements to arommerskirchen@csi.com
// $Id: abcptrlibfact.cpp,v 1.1 2001/10/03 12:45:19 ar Exp $

#ifndef INCLUDED_ABCPTRPRGFACT_H
#	include "abcptrprgfact.h"
#	undef INCLUDED_ABCPTRPRGFACT_H
#	define INCLUDED_ABCPTRPRGFACT_H
#endif 

#ifndef INCLUDED_AR_UTILITY_ABCPTRINIT_H
#	include <ar/utility/abcptrinit.h>
#	undef INCLUDED_AR_UTILITY_ABCPTRINIT_H
#	define INCLUDED_AR_UTILITY_ABCPTRINIT_H
#endif

extern "C" {

void*
makeAX_InDll
	(
	int i_counter,
	AR::Utility::ABCPtrManager* i_manager
	);

}

//----------------------------------------------------------------------

AR::Utility::ABCPtr <X>
makeAX
	(
	int i_counter,
	AR::Utility::ABCPtrManager* i_manager
	) // throw whatever the ctor of VB or a derived class throws
{
	// factory in the program
	// load the dll on demand by the manager
	// lookup for the dll factory on demand
	// create a reference pointer object
	// ... and you know only the interface class X ...

	// the signature for the dll factory -- with or without 
	// extern C does not matter here

	typedef void*
	(*DLLFACTORY)
		(
		int i_counter,
		AR::Utility::ABCPtrManager* i_manager
		); 

	DLLFACTORY dllfact = reinterpret_cast <DLLFACTORY> (makeAX_InDll);

	// counter for dll -- one up ...
	i_manager->connect ();

	void* theObjRef;

	try
	{
		// use the patameter. if you need another, 
		// use another factory ...
		theObjRef = dllfact (i_counter, i_manager);
	}

	catch (...)
	{
		// memory is already freed inside dll factory
		i_manager->decrement ();

		throw;
	}

	AR::Utility::ABCPtrInit < X > p (theObjRef);

	return p;
}

// end of file

