// $Id: atrpmanager.cpp,v 1.2 2001/10/10 06:34:27 ar Exp $

/* Copyright (C) 2001 ATRSoft GmbH 
   This file is part of the ATRSoft GmbH utilitys.

   The ATRSoft GmbH utilitys is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or any later version.

   The ATRSoft GmbH utilitys is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the ATRSoft GmbH utilitys; see the file LICENSE.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

// http://www.atrsoft.de
// mailto: info@atrsoft.de

// visual c++ mfc add on. we dont need this if no afx app....
// for mfc apps you have to remove the double slashs 
// #include <stdafx.h>

//
// implementation of a manager
// use new and delete
//
// HOWTO:
// make a copy
// build it with 
// g++  -rdynamic -c atrpmanager.cpp 


#ifndef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRP_H
#	include <atrsoft/utility/include/atrp.h>
#	undef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRP_H
#	define INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRP_H
#endif

#ifndef INCLUDED_STDEXCEPT
#	include <stdexcept>
#	undef INCLUDED_STDEXCEPT
#	define INCLUDED_STDEXCEPT
#endif

#ifndef INCLUDED_STRING
#	include <string>
#	undef INCLUDED_STRING
#	define INCLUDED_STRING
#endif

//----------------------------------------------------------------------------
ATRSoft::Utility::AtrpManager::~AtrpManager
    (
    )
{
    disconnect ();
}

//----------------------------------------------------------------------------

ATRSoft::Utility::Chunk*
ATRSoft::Utility::AtrpManager::allocate
    (
    int i_count
    ) 
{
    // allocate the memory for the chunks - as char array, properly aligned
    // throw a bad_alloc, if memory is out

    char *p = new char [i_count];

    Chunk* cp = (ATRSoft::Utility::Chunk*)p;

    cp->s_.length_ = i_count;

    return cp;
}

//----------------------------------------------------------------------------
void
ATRSoft::Utility::AtrpManager::deallocate
    (
    ATRSoft::Utility::Chunk* i_mem
    ) 
{
    // free the memory of the chunks - as char array

    delete [] ((char*)i_mem);
}

//----------------------------------------------------------------------------

void
ATRSoft::Utility::AtrpManager::connect
    (
    ) 
{
}

//----------------------------------------------------------------------------

void
ATRSoft::Utility::AtrpManager::disconnect
    (
    ) 
{
    decrement ();
}

//----------------------------------------------------------------------------

void
ATRSoft::Utility::AtrpManager::decrement
    (
    ) 
{
}

//----------------------------------------------------------------------------

//Atrsoft::Utility::AtrpManager::Pfunc
//Atrsoft::Utility::AtrpManager::get_factory
//   (
//   ) 
//{
  // TODO : korrekte factory hier liefern
//	return (Pfunc)0;
//}

//----------------------------------------------------------------------------


// end of file
