// $Id: atrpfact.cpp,v 1.4 2001/10/10 06:34:27 ar Exp $
/* Copyright (C) 2001 ATRSoft GmbH 
   This file is part of the ATRSoft GmbH utilitys.

   The ATRSoft GmbH utilitys is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or any later version.

   The ATRSoft GmbH utilitys is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the ATRSoft GmbH utilitys; see the file LICENSE.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

// http://www.atrsoft.de
// mailto: info@atrsoft.de

// visual c++ mfc add on. we dont need this if no afx app....
// for mfc apps you have to remove the double slashs 
// #include <stdafx.h>

#ifndef INCLUDED_ATRPFACT_H
#	include "atrpfact.h"
#	undef INCLUDED_ATRPFACT_H
#	define INCLUDED_ATRPFACT_H
#endif 

#ifndef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRPINIT_H
#	include <atrsoft/utility/include/atrpinit.h>
#	undef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRPINIT_H
#	define INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRPINIT_H
#endif

//----------------------------------------------------------------------

// ok
// hier tun wir so als ob das ein ctor waere.
// er hat neben allen anderen parametern noch den pointer auf den zu nutzenden
// manager mit on bord
// daneben die ueblichen arameter
//
// HOWTO
// file kopieren und name anpassen. dann nutzen 
//

ATRSoft::Utility::Atrp <X>
makeAX
    (
    int i_counter,
    ATRSoft::Utility::AtrpManager* i_manager
    ) // throw whatever the ctor of X or a derived class throws
{
    // factory in the program
    // load the dll on demand by the manager
    // lookup for the dll factory on demand
    // create a reference pointer object
    // ... and you know only the interface class X ...

    // the signature for the dll factory -- with or without 
    // extern C does not matter here

    typedef void*
	(*SOFACTORY)
	    (
	    int i_counter,
	    ATRSoft::Utility::AtrpManager* i_manager
	    ); 

    SOFACTORY sofact = reinterpret_cast <SOFACTORY> (i_manager->get_factory ());

    // counter for dll -- one up ...
    i_manager->connect ();

    void* theObjRef;

    try
    {
	// use the patameter. if you need another, 
	// use another factory ...
	theObjRef = sofact (i_counter, i_manager);

	// constuct a helper which is in memory
	// layout ok and can be converted to a Atrp 
	ATRSoft::Utility::AtrpInit<X> p(theObjRef);
    
	return p;
    }

    catch (...)
    {
	// memory is already freed inside dll factory
	i_manager->decrement ();

	throw;
    }
}

// end of file

